/* Sistemas Integrados TEKNISA
   Compras e Suprimentos

Nome: 8250_CMPSTPO_CAD_OL.sql

Descrio:
Stored procedure para a vinculao de todas as filiais existentes
a um determinado subgrupo de produtos e respectivo operador logstico.

Criao:
15/09/2005 Marcelo Alexsandro Souza Silva.
*/

CREATE OR REPLACE
PROCEDURE CAD_OL(
   P_CDFILIAL     IN FILIAL.CDFILIAL%TYPE,
   P_CDGRUPPROD   IN PRSUBGRPROD.CDGRUPPROD%TYPE,
   P_CDSUBGRPROD  IN PRSUBGRPROD.CDSUBGRPROD%TYPE) IS

   V_NRSEQPARPROD PARAMPRODSUP.NRSEQPARPROD%TYPE;
   V_CDFILIOPELOG PARAMPRODSUP.CDFILIOPELOG%TYPE;
   V_PRXCODIGO VARCHAR2(20);
   V_CONT_COMMIT_I NUMBER := 0;
   V_QTDE_COMMIT_I NUMBER := 500;
   V_CONT_COMMIT_U NUMBER := 0;
   V_QTDE_COMMIT_U NUMBER := 200;
BEGIN
   FOR CUR_PRODUTO IN
      (SELECT
          PRSUBGRPROD.CDPRODUTO,
          FILIAL.CDFILIAL
       FROM
          FILIAL,
          PRSUBGRPROD
       WHERE
          PRSUBGRPROD.CDGRUPPROD  = P_CDGRUPPROD  AND
          PRSUBGRPROD.CDSUBGRPROD = P_CDSUBGRPROD AND
          PRSUBGRPROD.CDFILISUBGR = 'P'           AND
          NVL(FILIAL.IDFUNCAOFILI, '') <> 'O')
   LOOP
      V_NRSEQPARPROD := '';
      V_CDFILIOPELOG := '';
      SELECT
         MAX(NRSEQPARPROD),
         MAX(CDFILIOPELOG)
      INTO
         V_NRSEQPARPROD,
         V_CDFILIOPELOG
      FROM
         PARAMPRODSUP
      WHERE
         PARAMPRODSUP.CDPRODUTO   = CUR_PRODUTO.CDPRODUTO AND
         PARAMPRODSUP.CDFILIAL    = CUR_PRODUTO.CDFILIAL;

      IF (V_NRSEQPARPROD IS NULL) THEN
         NOVO_CODIGO('PARAMPRODSUP', V_PRXCODIGO);
         V_PRXCODIGO := SUBSTR(V_PRXCODIGO,11,10);
         INSERT INTO PARAMPRODSUP
           (NRSEQPARPROD, CDFILIAL, CDPRODUTO, CDFILIOPELOG,
            CDGRUPPROD, CDSUBGRPROD, CDFILISUBGR)
         VALUES
           (V_PRXCODIGO, CUR_PRODUTO.CDFILIAL, CUR_PRODUTO.CDPRODUTO, P_CDFILIAL,
            P_CDGRUPPROD, P_CDSUBGRPROD, 'P');
         V_CONT_COMMIT_I := V_CONT_COMMIT_I + 1;
         IF (V_CONT_COMMIT_I >= V_QTDE_COMMIT_I) THEN
            V_CONT_COMMIT_I := 0;
            COMMIT;
         END IF;
      ELSE
         IF (V_CDFILIOPELOG <> P_CDFILIAL OR V_CDFILIOPELOG IS NULL) THEN
            UPDATE PARAMPRODSUP
            SET
               CDFILIAL     = CUR_PRODUTO.CDFILIAL,
               CDPRODUTO    = CUR_PRODUTO.CDPRODUTO,
               CDFILIOPELOG = P_CDFILIAL,
               CDGRUPPROD   = P_CDGRUPPROD,
               CDSUBGRPROD  = P_CDSUBGRPROD,
               CDFILISUBGR  = 'P'
            WHERE
               NRSEQPARPROD = V_NRSEQPARPROD;
            V_CONT_COMMIT_U := V_CONT_COMMIT_U + 1;
            IF (V_CONT_COMMIT_U >= V_QTDE_COMMIT_U) THEN
               V_CONT_COMMIT_U := 0;
               COMMIT;
            END IF;
         END IF;
      END IF;
   END LOOP;
   COMMIT;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('CAD_OL','4.05.104'); END;
/

