/* Sistemas Integrados TEKNISA
   Compras e Suprimentos

Nome: 8169_CMPVIEO_V_PREVISAO_COMPRA.sql

Descrio:
Previso de Compras para o clculo da necessidade de compras

Criao:
05/01/2007 Marcelo Alexsandro Souza Silva
*/

CREATE OR REPLACE FORCE VIEW SF_V_PREVISAO_COMPRA ("CDFILIAL", "CDPRODUTO", "QTPREVCONS", "DTPREVCONS", "NRORG") AS
  SELECT PC.CDFILIAL, PC.CDPRODUTO, PC.QTPREVCONS, TRUNC(PC.DTPREVCONS) AS DTPREVCONS, PC.NRORG
  FROM PREVCONS PC
  UNION ALL
  SELECT PC_PDV.CDFILIAL, P.CDPRODESTO AS CDPRODUTO, (PC_PDV.QTPRODCONPDVDIA*P.VRFATOCONV) AS QTPREVCONS, TRUNC(PC_PDV.DTPRODCONPDV) AS DTPREVCONS, PC_PDV.NRORG
  FROM PREVCONSPDVDIA PC_PDV, PRODUTO P
  WHERE  PC_PDV.CDPRODUTO = P.CDPRODUTO
    AND PC_PDV.NRORG = P.NRORG
    AND NOT EXISTS (SELECT 1 FROM ROTFABRICA WHERE ROTFABRICA.CDPRODUTO = PC_PDV.CDPRODUTO)
    AND NOT EXISTS (SELECT 1
                    FROM ROTFABLOCAL
                    WHERE ROTFABLOCAL.CDPRODUTO = PC_PDV.CDPRODUTO
                      AND ROTFABLOCAL.NRORG     = PC_PDV.NRORG
                      AND ROTFABLOCAL.CDFILIAL  = PC_PDV.CDFILIAL)
  UNION ALL
  SELECT PC_PDV.CDFILIAL, P.CDPRODESTO AS CDPRODUTO, (ROT.QTSUBPRODROT*PC_PDV.QTPRODCONPDVDIA*P.VRFATOCONV) AS QTPREVCONS, TRUNC(PC_PDV.DTPRODCONPDV) AS DTPREVCONS, PC_PDV.NRORG
  FROM PREVCONSPDVDIA PC_PDV, PRODUTO P, ROTFABRICA ROT
  WHERE  ROT.CDSUBPRODUTO = P.CDPRODUTO
    AND ROT.NRORG     = P.NRORG
    AND ROT.CDPRODUTO = PC_PDV.CDPRODUTO
    AND ROT.NRORG     = PC_PDV.NRORG
    AND NOT EXISTS (SELECT 1
                    FROM ROTFABLOCAL
                    WHERE ROTFABLOCAL.CDFILIAL = PC_PDV.CDFILIAL
                      AND ROTFABLOCAL.CDPRODUTO = PC_PDV.CDPRODUTO
                      AND ROTFABLOCAL.NRORG = PC_PDV.NRORG)
  UNION ALL
  SELECT PC_PDV.CDFILIAL, P.CDPRODESTO AS CDPRODUTO, (ROT.QTSUBPRODLOC*PC_PDV.QTPRODCONPDVDIA*P.VRFATOCONV) AS QTPREVCONS, TRUNC(PC_PDV.DTPRODCONPDV) AS DTPREVCONS, PC_PDV.NRORG
  FROM PREVCONSPDVDIA PC_PDV, PRODUTO P, ROTFABLOCAL ROT
  WHERE  ROT.CDSUBPRODLOC = P.CDPRODUTO
     AND ROT.NRORG        = P.NRORG
     AND ROT.CDPRODUTO    = PC_PDV.CDPRODUTO
     AND ROT.CDFILIAL     = PC_PDV.CDFILIAL
     AND ROT.NRORG        = PC_PDV.NRORG
  UNION ALL
  SELECT CDFILIALCLIE AS CDFILIAL, CDPRODUTO, QTSOLCONVMN AS QTPREVCONS, TRUNC(DTPREVENDVMN) AS DTPREVCONS, NRORG
  FROM PREVCONSVMN
  UNION ALL
  SELECT CDFILIAL, CDPRODUTO, QTPREVCONPME AS QTPREVCONS, TRUNC(DTPREVCONPME) AS DTPREVCONS, NRORG
  FROM PREVCONSPME
  UNION ALL
  SELECT CDFILIAL, CDPRODUTO, QTPRODCOMP AS QTPREVCONS, TRUNC(DTPREVCOMP) AS DTPREVCONS, NRORG
  FROM PREVCOMPRA
  UNION ALL
  SELECT CDFILIAL, CDPRODUTO, QTPREVCOMP AS QTPREVCONS, TRUNC(DTENTPRECOMP) AS DTPREVCONS, NRORG
  FROM ITPREVCOMP
  WHERE ITPREVCOMP.IDSTITPRCOMP = 'A'
  UNION ALL
  SELECT F.CDFILCENTPME AS CDFILIAL, P.CDPRODESTO AS CDPRODUTO, (QTSOLIPROD*VRFATOCONV) AS QTPREVCONS, TRUNC(DTPROGENTR) AS DTPREVCONS, ITEMSOLI.NRORG
  FROM ITEMSOLI, FILIAL F, PRODUTO P
  WHERE NVL(ITEMSOLI.IDITMCONS, 'N')   = 'N'
    AND NVL(ITEMSOLI.IDSOLIAPROV, 'S') = 'S'
    AND F.CDFILCENTPME                 IS NOT NULL
    AND ITEMSOLI.CDFILSOLI             = F.CDFILIAL
    AND ITEMSOLI.CDPRODUTO             = P.CDPRODUTO
    AND ITEMSOLI.NRORG                 = P.NRORG
    AND ITEMSOLI.NRORG                 = F.NRORG
    AND NOT EXISTS (SELECT CMPCENTENDIR.CDFILIAL, CMPCENTENDIR.CDPRODUTO
                    FROM PRODUTO PC, CMPCENTENDIR
                    WHERE CMPCENTENDIR.CDFILIAL  = ITEMSOLI.CDFILSOLI
                      AND CMPCENTENDIR.CDPRODUTO = PC.CDPRODUTO
                      AND CMPCENTENDIR.NRORG     = ITEMSOLI.NRORG
                      AND PC.NRORG               = ITEMSOLI.NRORG
                      AND P.CDARVPROD           LIKE PC.CDARVPROD || '%')
/

-- VERSAO --
BEGIN ATUVEROBJ('SF_V_PREVISAO_COMPRA','5.05.094'); END;
/

CREATE OR REPLACE FORCE VIEW SF_V_PREVISAO_COMPRA_FILIAL ("CDFILIAL", "CDPRODUTO", "QTPREVCONS", "DTPREVCONS", "NRORG") AS
  SELECT FN.CDFILIAL, PC.CDPRODUTO, PC.QTPREVCONS, TRUNC(PC.DTPREVCONS) AS DTPREVCONS, PC.NRORG
  FROM PREVCONS PC, FILIAL F, FILINECE FN
  WHERE NVL(F.IDFILCENTPME, 'N') = 'N'
    AND FN.IDSOLIPREV            = 'P'
    AND FN.CDFILIAL              = F.CDFILIAL
    AND PC.CDFILIAL              = FN.CDFILINECCMP
    AND PC.NRORG                 = F.NRORG
    AND PC.NRORG                 = FN.NRORG
  UNION ALL
  SELECT FN.CDFILIAL, P.CDPRODESTO AS CDPRODUTO, (PC_PDV.QTPRODCONPDVDIA*P.VRFATOCONV) AS QTPREVCONS, TRUNC(PC_PDV.DTPRODCONPDV) AS DTPREVCONS, PC_PDV.NRORG
  FROM PREVCONSPDVDIA PC_PDV, FILIAL F, FILINECE FN, PRODUTO P
  WHERE PC_PDV.CDPRODUTO         = P.CDPRODUTO
    AND NVL(F.IDFILCENTPME, 'N') = 'N'
    AND FN.IDSOLIPREV            = 'P'
    AND FN.CDFILIAL              = F.CDFILIAL
    AND PC_PDV.CDFILIAL          = FN.CDFILINECCMP
    AND PC_PDV.NRORG             = F.NRORG
    AND PC_PDV.NRORG             = FN.NRORG
    AND PC_PDV.NRORG             = P.NRORG
    AND NOT EXISTS (SELECT 1 FROM ROTFABRICA WHERE ROTFABRICA.CDPRODUTO = PC_PDV.CDPRODUTO)
    AND NOT EXISTS (SELECT 1
                    FROM ROTFABLOCAL
                    WHERE ROTFABLOCAL.CDPRODUTO = PC_PDV.CDPRODUTO
                      AND ROTFABLOCAL.CDFILIAL  = PC_PDV.CDFILIAL
                      AND ROTFABLOCAL.NRORG     = PC_PDV.NRORG)
  UNION ALL
  SELECT FN.CDFILIAL, P.CDPRODESTO AS CDPRODUTO, (ROT.QTSUBPRODROT*PC_PDV.QTPRODCONPDVDIA*P.VRFATOCONV) AS QTPREVCONS, TRUNC(PC_PDV.DTPRODCONPDV) AS DTPREVCONS, PC_PDV.NRORG
  FROM PREVCONSPDVDIA PC_PDV, FILIAL F, FILINECE FN, PRODUTO P, ROTFABRICA ROT
  WHERE ROT.CDSUBPRODUTO = P.CDPRODUTO
    AND ROT.CDPRODUTO = PC_PDV.CDPRODUTO
    AND NVL(F.IDFILCENTPME, 'N') = 'N'
    AND FN.IDSOLIPREV            = 'P'
    AND FN.CDFILIAL              = F.CDFILIAL
    AND PC_PDV.CDFILIAL          = FN.CDFILINECCMP
    AND PC_PDV.NRORG             = F.NRORG
    AND PC_PDV.NRORG             = FN.NRORG
    AND PC_PDV.NRORG             = P.NRORG
    AND PC_PDV.NRORG             = ROT.NRORG
    AND NOT EXISTS (SELECT 1
                    FROM ROTFABLOCAL
                    WHERE ROTFABLOCAL.CDFILIAL  = PC_PDV.CDFILIAL
                      AND ROTFABLOCAL.CDPRODUTO = PC_PDV.CDPRODUTO
                      AND ROTFABLOCAL.NRORG     = PC_PDV.NRORG)

  UNION ALL
  SELECT FN.CDFILIAL, P.CDPRODESTO AS CDPRODUTO, (ROT.QTSUBPRODLOC*PC_PDV.QTPRODCONPDVDIA*P.VRFATOCONV) AS QTPREVCONS, TRUNC(PC_PDV.DTPRODCONPDV) AS DTPREVCONS, PC_PDV.NRORG
  FROM PREVCONSPDVDIA PC_PDV, FILIAL F, FILINECE FN, PRODUTO P, ROTFABLOCAL ROT
  WHERE ROT.CDSUBPRODLOC = P.CDPRODUTO
    AND ROT.CDPRODUTO = PC_PDV.CDPRODUTO
    AND ROT.CDFILIAL  = PC_PDV.CDFILIAL
    AND NVL(F.IDFILCENTPME, 'N') = 'N'
    AND FN.IDSOLIPREV            = 'P'
    AND FN.CDFILIAL              = F.CDFILIAL
    AND PC_PDV.CDFILIAL          = FN.CDFILINECCMP
    AND PC_PDV.NRORG             = F.NRORG
    AND PC_PDV.NRORG             = FN.NRORG
    AND PC_PDV.NRORG             = P.NRORG
    AND PC_PDV.NRORG             = ROT.NRORG
  UNION ALL
  SELECT FN.CDFILIAL, CDPRODUTO, QTSOLCONVMN AS QTPREVCONS, TRUNC(DTPREVENDVMN) AS DTPREVCONS, PC.NRORG
  FROM PREVCONSVMN PC, FILIAL F, FILINECE FN
  WHERE NVL(F.IDFILCENTPME, 'N') = 'N'
    AND FN.IDSOLIPREV            = 'P'
    AND FN.CDFILIAL              = F.CDFILIAL
    AND PC.CDFILIALCLIE          = FN.CDFILINECCMP
    AND PC.NRORG                 = F.NRORG
    AND PC.NRORG                 = FN.NRORG
  UNION ALL
  SELECT FN.CDFILIAL, PC.CDPRODUTO, PC.QTPREVCONPME AS QTPREVCONS, TRUNC(PC.DTPREVCONPME) AS DTPREVCONS, PC.NRORG
  FROM PREVCONSPME PC, FILIAL F, FILINECE FN
  WHERE NVL(F.IDFILCENTPME, 'N') = 'N'
    AND FN.IDSOLIPREV            = 'P'
    AND FN.CDFILIAL              = F.CDFILIAL
    AND PC.CDFILIAL              = FN.CDFILINECCMP
    AND PC.NRORG                 = F.NRORG
    AND PC.NRORG                 = FN.NRORG
  UNION ALL
  SELECT FN.CDFILIAL, PC.CDPRODUTO, PC.QTPRODCOMP AS QTPREVCONS, TRUNC(PC.DTPREVCOMP) AS DTPREVCONS, PC.NRORG
  FROM PREVCOMPRA PC, FILIAL F, FILINECE FN
  WHERE NVL(F.IDFILCENTPME, 'N') = 'N'
    AND FN.IDSOLIPREV            = 'P'
    AND FN.CDFILIAL              = F.CDFILIAL
    AND PC.CDFILIAL              = FN.CDFILINECCMP
    AND PC.NRORG                 = F.NRORG
    AND PC.NRORG                 = FN.NRORG
  UNION ALL
  SELECT FN.CDFILIAL, PC.CDPRODUTO, PC.QTPREVCOMP AS QTPREVCONS, TRUNC(PC.DTENTPRECOMP) AS DTPREVCONS, PC.NRORG
  FROM ITPREVCOMP PC, FILIAL F, FILINECE FN
  WHERE NVL(F.IDFILCENTPME, 'N') = 'N'
    AND PC.IDSTITPRCOMP          = 'A'
    AND FN.IDSOLIPREV            = 'P'
    AND FN.CDFILIAL              = F.CDFILIAL
    AND PC.CDFILIAL              = FN.CDFILINECCMP
    AND PC.NRORG                 = F.NRORG
    AND PC.NRORG                 = FN.NRORG
  UNION ALL
  SELECT FI.CDFILIAL, PR.CDPRODESTO AS CDPRODUTO, (IT.QTSOLIPROD*PR.VRFATOCONV) AS QTPREVCONS, TRUNC(IT.DTPROGENTR) AS DTPREVCONS, IT.NRORG
  FROM ITEMSOLI IT, PRODUTO PR, FILINECE FI, FILIAL
  WHERE FI.CDFILIAL                    = FILIAL.CDFILIAL
    AND NVL(FILIAL.IDFILCENTPME, 'N')  = 'N'
    AND FI.CDFILINECCMP                = IT.CDFILSOLI
    AND FI.IDSOLIPREV                  = 'S'
    AND IT.CDPRODUTO                   = PR.CDPRODUTO
    AND IT.NRORG                       = PR.NRORG
    AND IT.NRORG                       = FI.NRORG
    AND IT.NRORG                       = FILIAL.NRORG
/

-- VERSAO --
BEGIN ATUVEROBJ('SF_V_PREVISAO_COMPRA_FILIAL','0.00.000'); END;
/
